import React from "react";
import GrammarView from "./GrammarView";
import { Grammar, RightSide, Rule } from "../App";
const GrammarList = ({
  grammars,
  deleteGr,
  editGr,
  addRule,
  duplicateGr,
  deleteRule,
  changeRule,
  generateFile,
  changeRoot,
  getFile,
  fileToGrammar,
  deleteFile,
  deleteFilesFromGrammar,
}: {
  grammars: Grammar[];
  deleteGr: (id: number) => Promise<void>;
  editGr: (Grammar: { uri: string; id: number }) => Promise<void>;
  addRule: (rule: Rule, grammarId: number) => Promise<void>;
  duplicateGr: (id: number) => Promise<void>;
  deleteRule: (
    ruleId: number,
    root: boolean,
    grammarId: number
  ) => Promise<void>;
  changeRule: (
    ruleId: number,
    rule: { leftSymbol: string | null; rightSide: RightSide[] | null },
    grammarId: number
  ) => Promise<void>;
  generateFile: (
    xml: boolean,
    grammarId: number,
    save: boolean
  ) => Promise<void>;
  changeRoot: (id: number, grammarId: number, oldRule: Rule) => Promise<void>;
  getFile: (id: number, grammarId: number) => Promise<void>;
  fileToGrammar: (
    file: string,
    xml: boolean|null,
    grammarId: number,
    save: boolean,
    diff: boolean
  ) => Promise<void>;
  deleteFile: (fileId: number, grammarId: number) => Promise<void>;
  deleteFilesFromGrammar: (grammarId: number) => Promise<void>;
}) => {
  return (
    <div>
      {grammars.map((grammar) => (
        <GrammarView
          key={grammar.id}
          grammar={grammar}
          deleteGr={deleteGr}
          editGr={editGr}
          addRule={addRule}
          duplicateGr={duplicateGr}
          deleteRule={deleteRule}
          changeRule={changeRule}
          generateFile={generateFile}
          changeRoot={changeRoot}
          getFile={getFile}
          fileToGrammar={fileToGrammar}
          deleteFile={deleteFile}
          deleteFilesFromGrammar={deleteFilesFromGrammar}
        />
      ))}
    </div>
  );
};

export default GrammarList;
